"""
========================================
  Introduction to Computer Programming
========================================

----------------------------------------------------
  examples for lab A
----------------------------------------------------
"""

from random import random


def build_list_of_lists(rows, columns, initial_value):
    grid = []
    for _ in range(rows):
        row = []
        for _ in range(columns):
            row.append(initial_value)
        grid.append(row)
    return grid


def make_grid(rows, columns, density):
    grid = []
    for _ in range(rows):
        row = []
        for _ in range(columns):
            row.append(random() < density)
        grid.append(row)
    return grid


def extract_points(g):
    points = []
    for y in range(len(g)):
        row = g[y]
        for x in range(len(row)):
            if g[y][x]:
                points.append((x, y))
    return points


def add_points_to_grid(g, points):
    for p in points:
        x = p[0]
        y = p[1]
        g[y][x] = True


# -----------------------------------------------------------------
# opening a graphic window of specified size
# using an event-loop timer to "move" a block
# using global variable to remember position of block

from grid_graphics import (open_window, get_dimensions,
                           paint, unpaint, set_timer, event_loop)


_thing_x = 0


def graphic_loop_example():
    open_window(columns=50, rows=10, title='simple example')
    set_timer(move_thing, 1)   # so it starts right away
    event_loop()


def move_thing():
    global _thing_x
    (columns, rows) = get_dimensions()
    unpaint((_thing_x, 0))
    if _thing_x < columns:
        _thing_x += 1
    else:
        _thing_x = 0   # wrap around effect
    paint((_thing_x, 0), 'orange')
    set_timer(move_thing, 200)  # repeat every 2/10th of second
